import { Idl } from '@coral-xyz/anchor';
import { Project } from 'ts-morph';

declare function genErrors(project: Project, idl: Idl, outPath: (path: string) => string): void;
declare function genIndex(project: Project, idl: Idl, outPath: (path: string) => string): void;
declare function genCustomErrors(project: Project, idl: Idl, outPath: (path: string) => string): void;
declare function genAnchorErrors(project: Project, idl: Idl, outPath: (path: string) => string): void;

export { genAnchorErrors, genCustomErrors, genErrors, genIndex };
